
import net.mikekohn.java_grinder.CPU;
import net.mikekohn.java_grinder.IOPort0;
import net.mikekohn.java_grinder.IOPort1;
import net.mikekohn.java_grinder.Timer;
import net.mikekohn.java_grinder.UART0;

public class StickyBuddy
{
  //static int data_flag = 128;
  //static int data = 0x7fff;

  static int interrupt_count = 0;
  static int speed_count = 0;
  static int rotate_value = 0;
  static final int LEVER = 0x80;
  static final int PROXIMITY = 0x40;
  static final int MOTOR_A0 = 0x01;
  static final int MOTOR_A1 = 0x02;
  static final int MOTOR_B0 = 0x04;
  static final int MOTOR_B1 = 0x08;
  static final int ALL_MOTORS = MOTOR_A0 | MOTOR_A1 | MOTOR_B0 | MOTOR_B1;

  static void delay_250ms()
  {
    interrupt_count = 0;

    while (interrupt_count != 625);
  }

  static void delay_350ms()
  {
    interrupt_count = 0;

    while (interrupt_count != 875);
  }

  static void delay(int seconds)
  {
    for (int n = 0; n < seconds; n++)
    {
      interrupt_count = 0;
      while (interrupt_count != 2500);
    }
  }

  static void lower()
  {
    //servo_new = 5;
    IOPort0.setPinsHigh(LEVER);
  }

  static void raise()
  {
    //servo_new = 3;
    IOPort0.setPinsLow(LEVER);
  }

  static void forward()
  {
    IOPort1.setPinsLow(ALL_MOTORS);
    IOPort1.setPinsHigh(MOTOR_A1 | MOTOR_B0);
  }

  static void back()
  {
    IOPort1.setPinsLow(ALL_MOTORS);
    IOPort1.setPinsHigh(MOTOR_A0 | MOTOR_B1);
  }

  static void left()
  {
    IOPort1.setPinsLow(ALL_MOTORS);
    //IOPort1.setPinsHigh(MOTOR_A0 | MOTOR_B0);
    setRotate(MOTOR_A0 | MOTOR_B0);
  }

  static void right()
  {
    IOPort1.setPinsLow(ALL_MOTORS);
    //IOPort1.setPinsHigh(MOTOR_A1 | MOTOR_B1);
    setRotate(MOTOR_A1 | MOTOR_B1);
  }

  static void stop()
  {
    rotate_value = 0;
    IOPort1.setPinsLow(ALL_MOTORS);
  }

  static void setRotate(int value)
  {
    speed_count = 0;
    stop();
    rotate_value = value;
  }

  static void runTest()
  {
    delay(2);

    forward();
    delay(2);
    stop();

    lower();
    delay_250ms();
    delay_250ms();
    forward();
    delay_350ms();
    stop();
    delay(1);

    left();
    delay(2);
    stop();
    delay(2);

    right();
    delay(2);
    stop();
    delay(2);

    raise();
  }

  static public void main(String args[])
  {
    // Set the DCO to 1MHz
    CPU.setClock1();

    // Setup UART.
    UART0.init(UART0.BAUD_9600);

    // Setup control pins.
    IOPort0.setPinsAsOutput(LEVER);
    IOPort1.setPinsAsOutput(MOTOR_A0 | MOTOR_A1 | MOTOR_B0 | MOTOR_B1);
    IOPort0.setPinsValue(0);
    IOPort1.setPinsValue(0);
    //IOPort0.setPinsResistorEnable(BUTTON);

    // Setup timer interrupt (aka, Java listener).
    // 1,000,000 * 0.0004 (0.4ms) = 400
    Timer.setInterval(400, 1);
    Timer.setListener(true);

    //UART0.send(65);

    //runTest();

    while (true)
    {
/*
      if ((IOPort0.getPortInputValue() & PROXIMITY) == 0)
      {
        stop();
        UART0.send('*');
      }
*/

      if (UART0.isDataAvailable())
      {
        int c = UART0.read();

        if (c == 'u')
        {
          raise();
        }
          else
        if (c == 'd')
        {
          lower();
        }
          else
        if (c == 'l')
        {
          left();
        }
          else
        if (c == 'r')
        {
          right();
        }
          else
        if (c == 'f')
        {
          forward();
        }
          else
        if (c == 'b')
        {
          back();
        }
          else
        if (c == 's')
        {
          stop();
        }
      }
    }
  }

  public void timerInterrupt()
  {
    interrupt_count++;

    // 50 interrupts = 20.0ms
    // 25 interrupts = 10.0ms
    //  5 interrupts =  2.0ms
    if (rotate_value != 0)
    {
      speed_count++;

      if (speed_count == 50)
      {
        IOPort1.setPinsHigh(rotate_value);
        speed_count = 0;
      }
        else
      if (speed_count == 10)
      {
        IOPort1.setPinsLow(ALL_MOTORS);
      }
    }
  }
}

